<?php
/**************************************************************************
Copyright (C) 2015  Apostolos Malatras

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>
***************************************************************************/
include "manualcore.php";
include "filetoarrstr.php";

$help= "\nManual tree pruning algorithm\nUsage:\n\nphp $argv[0] -n <newickfile> -l <listfile> -d|-r\n\nOptions:\n\t-n <newickfile>\tTree file in Newick format\n\t-l <listfile>\tList with leaves\n\t-d\t\tDelete leaves from list\n\t-r\t\tRetain leaves from list\n\t-h\t\tThis message\n";
$flagl=0;
$flagn=0;
$delp=NULL;
if($argc==1){
	echo $help;
}
//if for help
else if($argv[1]==("-h")){
	echo $help;
}
else{
	for($i=0;$i<$argc;$i++){
		if($argv[$i]=="-n"){
			$plusn=$i+1;
			if(is_file($argv[$plusn])){
				$flagn=1;
			}else{
				exit("The newick file does not exists.");
			}
		}
		else if(($i==$argc-1) & $flagn==0){
				exit("The newick file does not exists.");
		}
		if($argv[$i]=="-l"){
			$plusl=$i+1;
			if(is_file($argv[$plusl])){
				$flagl=1;
			}else{
				exit("The list file does not exists.");
			}
		}
		else if(($i==$argc-1) & $flagl==0){
				exit("The list file does not exists.");
		}
		if($argv[$i]=="-d"){
			$delp="d";
		}
		elseif($argv[$i]=="-r"){
			$delp="r";
		}
	}
	if ($delp==NULL){
		exit("No parameter was set: -d to delete, -r to retain\n");
	}
	
	$argv[$plusl]=filetoarrstr($argv[$plusl]);
	$new=treetrim($argv[$plusn], $argv[$plusl], $delp);
	echo "$new\n";
}
?>