<?php
/**************************************************************************
Copyright (C) 2015  Apostolos Malatras

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>
***************************************************************************/
ini_set("memory_limit","6144M");
include "mmcore.php";

$help= "\nPhyloprune: An automated phylogenetic tree pruning algorithm\nUsage:\n\nphp $argv[0] -i <inputfile> -o <outputfile> \n[ -f <n> -l <m> -s <s> -d ]\n\nOptions:\n\t-i <inputfile>\tInput file in Newick format\n\t-o <outputfile>\tOutput pruned tree in Newick format\n\t-f <integer>\tDisplay pruned trees at iteration (default: All)\n\t-l <integer>\tLeaves left after pruning (default: 2)\n\t-s <integer>\tStep (default: 1)\n\t-minmax | -maxmax <prune type> \n\t\t\tmax overall distance, retain min leaf (default) | max overall distance, retain max leaf\n\t-d\t\tWrite output in a single file\n\t-h\t\tThis message\n";
$flagin=0;
$flagout=0;
$flagf=0;
$flagl=0;
$flags=0;
$flagd=0;
if($argc==1){
	echo $help;
}
//if for help
else if($argv[1]==("-h")){
	echo $help;
}
else{
	//seperate argv input,output,f,l,s
	for($i=0;$i<$argc;$i++){
		if($argv[$i]=="-i"){
			$plusin=$i+1;
			if(is_file($argv[$plusin])){
				$flagin=1;
			}else{
				exit("The input file does not exists.");
			}
		}
		else if(($i==$argc-1) & $flagin==0){
				exit("The input file does not exists.");
		}
		if($argv[$i]=="-o"){
			$plusout=$i+1;
			$flagout=1;
		}
		else if(($i==$argc-1) & $flagout==0){
			exit("The output file does not exists.");
		}
		if($argv[$i]=="-f"){
			$plusf=$i+1;
			settype($argv[$plusf], "int");
			if($argv[$plusf]){
				$argumf=$argv[$plusf];
				$flagf=1;
			}else{
				exit("-f must be an int number.");
			}
		}
		if($argv[$i]=="-l"){
			$plusl=$i+1;
			settype($argv[$plusl], "int");
			if($argv[$plusl]){
				$arguml=$argv[$plusl];
				$flagl=1;
			}else{
				exit("-l must be an int number.");
			}
		}
		if($argv[$i]=="-s"){
			$pluss=$i+1;
			settype($argv[$pluss], "int");
			if($argv[$pluss]){
				$argums=$argv[$pluss];
				$flags=1;
			}else{
				exit("-s must be an int number.");
			}
		}
		if($argv[$i]=="-d"){
			$flagd=1;
		}
		if($argv[$i]=="-maxmin"){
			$argummm="maxmin";
		}
		if($argv[$i]=="-maxmax"){
			$argummm="maxmax";
		}
	}


	if(!isset($argumf)) {
		$argumf=0;
	}
	if(!isset($arguml)) {
		$arguml=0;
	}
	if(!isset($argums)) {
		$argums=0;
	}
	if(!isset($argummm)){
		$argummm="maxmin";
	}

	mmcore($argv[$plusin],$argv[$plusout],$argumf,$arguml,$argums,$argummm,$flagf,$flagl,$flags,$flagd);
}
?>
